<?php

/**
 * My Live Streams widget
 */
class LSB_Stream_Status_Widget extends WP_Widget {
	
	function LSB_Stream_Status_Widget() {
		parent::WP_Widget(false, $name = 'LSB Stream Status');
	}
	
	static function sort_links_by_description_as_num($la, $lb) {
		$count_a = (int) $la->description;
		$count_b = (int) $lb->description;
		
		if ($count_a == $count_b)
			return 0;
		
		$natural = ($count_a > $count_b) ? 1 : -1;
		return (-1) * $natural;
	}

	function widget($args, $instance) {
		// Get menu items for configured menu
		$menu_items = !empty($instance['menu_id']) ? wp_get_nav_menu_items( $instance['menu_id'] ) : false;

		// No menu selected
		if (!$menu_items)
			return;
		
		$instance['title'] = apply_filters('widget_title', !empty( $instance['title'] ) ? $instance['title'] : '');
		
		echo $args['before_widget'];
		
		if (!empty($instance['title'])) {
			echo $args['before_title']. $instance['title']. $args['after_title'];
		}

		// Get only those with links
		$links = array();
		foreach ($menu_items as $m) {
			if (empty($m->url) || empty($m->title))
				continue;

			$links[] = $m; 
		}

		usort($links, array('LSB_Stream_Status_Widget', 'sort_links_by_description_as_num'));
		?>

		<div><table class="lsb-widget-table">
		<?php
		foreach ($links as $link) {
			$is_on = ($link->description != -1);
			?>
			<tr>
				<td class="lsb-widget-table-stream-col"><a href="<?php echo $link->url; ?>" target="_blank"><?php echo apply_filters( 'the_title', $link->title ); ?></a></td>
				<td class="lsb-widget-table-status-col"><?php echo $is_on ? $link->description : 'Offline'; ?></td>
			</tr>			
			<?php
		}
		?>
		</table></div>

		<?php
		echo $args['after_widget'];
	} // widget()

	function update($new_instance, $old_instance) {
		$instance = $old_instance;

		$instance['title'] = strip_tags( stripslashes($new_instance['title']) );
		$instance['menu_id'] = (int) $new_instance['menu_id'];

		return $instance;
	}
	
	function form($instance) {
		$title = isset( $instance['title'] ) ? $instance['title'] : '';
		$menu_id = isset( $instance['menu_id'] ) ? $instance['menu_id'] : '';

		$menus = get_terms( 'nav_menu', array( 'hide_empty' => false) );

		// No menus available
		if ( !$menus ) {
			echo '<p>'. sprintf( __('No menus have been created yet. <a href="%s">Create some</a>.'), admin_url('nav-menus.php') ) .'</p>';
			return;
		}

		// Output options (title, menu select)
		?>
		<p>
			<label name="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title' ); ?></label>
			<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $title; ?>" /> 
		</p>
		<p>
			<label name="<?php echo $this->get_field_id( 'menu_id' ); ?>"><?php _e( 'Select menu:' ); ?></label>
			<select class="widefat" name="<?php echo $this->get_field_name( 'menu_id' ); ?>" id="<?php echo $this->get_field_id( 'menu_id' ); ?>">
		<?php
		foreach ( $menus as $menu ) {
			echo '<option value="' . $menu->term_id . '"' . selected( $menu_id, $menu->term_id, false ) . '>' . $menu->name . '</option>';
		}
		?>		
			</select>
		</p>				
		<?php
	} // form()
}

//eof